from mpi4py import MPI
import math
import numpy as np
import time
import sys
from common import *
from rook_map import *
from rook_map_new_scheme import *
from symmetric_diagonal_test import * 

comm = MPI.COMM_WORLD
worldSize = comm.Get_size()
rank = comm.Get_rank()
processorName = MPI.Get_processor_name()
TaskMaster = 0

c = 35.0
n = int(sys.argv[1])
size = [int(sys.argv[2]), int(sys.argv[3]), int(sys.argv[4])]
worldSize = int(sys.argv[5])
M = [i for i in range(1, n + 1)]
N = M
P = create_table(n)
Q = P


if rank != TaskMaster:
	#comm.barrier()
	n = len(M)
	A = []
	B = []
	for i in range(n):
		A.append(np.ones((size[0], size[1])))
	for i in range(n):
		B.append(np.ones((size[1], size[2])))	
	comm.barrier()
	# start = time.time()
	Ap = honerPolinomial(A, M, P, rank, worldSize)
		#Ap += A * (float(int(rank) / c) ** P[i])
	Bp = honerPolinomial(B, N, Q, rank, worldSize)
	# for i in range(n):
	# 	Bp += B * (float(int(rank) / c) ** Q[i])
	# end = time.time()
	comm.barrier()
	# request = comm.send(float(end - start), dest=TaskMaster, tag=0)
	#comm.barrier()


if rank == TaskMaster:
	result = []
	threshold = P[-1] + Q[-1] + 1
	comm.barrier()
	start = time.time()
	# while(len(result) < threshold):
	# 	st = MPI.Status()
	# 	comm.Probe(status=st)
	# 	i = st.source
	# 	result.append(comm.recv(source=i, tag=0))
	comm.barrier()
	end = time.time()
	print(float(end - start))

	# Matrix, Headers = PERMUTATIONS and values
	#comm.barrier()
	
	#comm.barrier()
	