from mpi4py import MPI
import math
import numpy as np
import time
import sys
from common import *
from rook_map import *
from rook_map_new_scheme import *

comm = MPI.COMM_WORLD
worldSize = comm.Get_size()
rank = comm.Get_rank()
processorName = MPI.Get_processor_name()
TaskMaster = 0

c = 35.0
n = int(sys.argv[1])
size = [int(sys.argv[2]), int(sys.argv[3]), int(sys.argv[4])]
M = [1, 2, 3, 4, 5]
N = M
P = [0, 1, 3, 4, 9]
Q = P


if rank != TaskMaster:
    Ap, Bp = comm.recv(source=TaskMaster, tag=100)
    ABp = np.dot(Ap, Bp)
    request = comm.send(ABp, dest=TaskMaster, tag=0)
    exit()


if rank == TaskMaster:
    threshold = 14
    indexAB = []
    Data = []
    ABp = []
    for i in range(worldSize - 1):
        ABp.insert(i, "")

    A = []
    B = []
    rand_A = np.random.rand(size[0], size[1])
    rand_B = np.random.rand(size[1], size[2])
    for i in range(n):
        A.append(np.copy(rand_A))
    for i in range(n):
        B.append(np.copy(rand_B))
    start = time.time()
    for worker_num  in range(1, worldSize):
        Ap = honerPolinomial(A, M, P, rank, worldSize)
        Bp = honerPolinomial(B, N, Q, rank, worldSize)
        # comm.send([Ap, Bp], dest=worker_num , tag=100)
    print_time(start)
    # start = time.time()
    # while(len(indexAB) < threshold):
    #     st = MPI.Status()
    #     comm.Probe(tag=0, status = st)
    #     i = st.source
    #     data = comm.recv(source = i, tag= 0)
    #     ABp.insert(i - 1, data)
    #     del ABp[i]
    #     indexAB.append(i)
    # indexAB.sort()
    # print_time(start)
    # start = time.time()
    # AB = Numpy_decode(ABp, indexAB, [size[0], size[1]], 1, 1, 1, threshold, worldSize) #1,1, 1 is m, p, n
    # end = time.time()
    # print_time(start)

    
